"""
An intro movie with clickable easter eggs. How cool?!
"""
#------------------------------IMPORTS-----------------------------------------#

import os
import sys

import pygame
from pygame.locals import *
from pygame.colordict import THECOLORS as COLORS

import data
#------------------------------GLOBALS-----------------------------------------#

FIRST_USABLE_EVENT = USEREVENT + 1

MOVE_STEP = FIRST_USABLE_EVENT + 3
TIME_OUT = FIRST_USABLE_EVENT + 4
BLIT_FONT = FIRST_USABLE_EVENT + 5


LE_QUIT = 0
LE_SKIP = 1
LE_NORMAL = 2


#------------------------------CLASSES-----------------------------------------#

class HotSpot:
    """
    A hot spot in the intro which shows you an easter egg or some other funny thing.
    """
    def __init__(self, image, hit_rect, pos=(0,0)):
        """
        """
        try:
            self.image = image
            self.hit_rect = hit_rect
            self.sur_hs, rect_hs = data.load_image(image)
            self.rect_hs = Rect(pos[0], pos[1], rect_hs.width, rect_hs.height)
            
        except Exception, error:
            error = "Initializing the HotSpot class failed:\n%s" % error
    
    def show(self, screen):
        """
        Blits the hot spot on the screen.
        """
        try:
            screen.blit(self.sur_hs, self.rect_hs)
        except Exception, error:
            error = "show in the intro class failed:\n%s" % error
            raise
#            
#class Subtitle:
#    """
#    Subtitles to show.
#    """
#    def __init__(self, text, font, color=COLORS["white"], size=30, words_in_sec=None, start_pos=(0,0)):
#        """
#        """
#        try:
#            self.text = text
#            self.font = font
#            self.size = size
#            self.color = color
#            self.words_in_sec = words_in_sec
#            print self.font
#            self.renderer = pygame.font.Font(self.font, self.size)
#            if None == self.words_in_sec:
#                self.sur_sub = self.renderer.render(selt.text)
#                self.parts = None
#            else:
#                self.parts = []
#                while "" != text:
#                    self.parts.append(text[0 : words_in_sec])
#                    text = text[words_in_sec:]
#                    
#                self.sur_sub = None
#                
#        except Exception, error:
#            error = "show in the intro class failed:\n%s" % error
#            raise
#    
#    def show_part(self):
#        """
#        Shows the text part by part.
#        """
#        if None == self.sur_sub:
#            pass
#            

class Intro:
    """
    An intro class that will make you bleed!
    """
    def __init__(self, screen):
        try:
            self.screen = screen
            
            self.intro_clock = pygame.time.Clock()
            
        except Exception, error:
            error = "Initializing the intro class failed:\n%s" % error
            raise
    
    def set_scene(self, image, hot_spots=[], rect=None, subs=None, move=False):
        """
        Sets the scene that will be shown.
        """
        try:
            self.move = move
            
            self.rect = rect
            self.subs = subs
            self.cur_image = image
            self.hot_spots = hot_spots
            self.sur_image, rect_image = data.load_image(image)
            
            if None != self.rect:
                self.rect_image = rect
            else:
                self.rect_image = Rect(0, 0, rect_image.width, rect_image.height)
            
            if (None != self.subs) and (None == self.subs.parts):
                self.sur_image.blit(self.subs.sur_subs, self.sur_rect)
                
            self.screen.blit(self.sur_image, self.rect_image)
            pygame.display.flip()
            
        except Exception, error:
            error = "set_scene in the intro class failed:\n%s" % error
            raise
            
    def start_loop(self, num_of_secs=15, stop_keys=[K_ESCAPE, K_RETURN]):
        try:
            need_flip = False
            showing_hs = -1
            shold_play = True
            
            step = 0
            
            #if self.subs:
            
            
            pygame.time.set_timer(TIME_OUT, num_of_secs * 1000)
            
            while shold_play:
                for event in pygame.event.get():
                    if QUIT == event.type:
                        return LE_QUIT
                    
                    #Quit if alt+f4 was hit:
                    elif ((KEYDOWN == event.type) and (K_F4 == event.key) and (KMOD_LALT == event.mod & KMOD_LALT)):
                        pygame.event.post(pygame.event.Event(QUIT))
                    
                    elif ((KEYDOWN == event.type) and ((event.key in stop_keys) or ("*" in stop_keys))):
                        return LE_SKIP
                    
                    elif TIME_OUT == event.type:
                        if (not self.move):
                            shold_play = False
                        else:
                            pygame.time.set_timer(MOVE_STEP, 1 * 10)
                            pygame.time.set_timer(TIME_OUT, 0)
                            self.hot_spots = []
                            
                    elif MOVE_STEP == event.type:
                        if (800 > step):
                            self.sur_image.set_clip(Rect(1 * step, 0, self.rect_image.width - 1 * step, self.rect_image.height))
                            self.screen.blit(self.sur_image, Rect(-1 * step, 0, self.rect_image.width, self.rect_image.height))
                            step += 1
                            need_flip = True
                        else:
                            pygame.time.set_timer(MOVE_STEP, 0)
                            pygame.time.set_timer(TIME_OUT, num_of_secs * 1000)
                            self.move = False
                    
                    elif MOUSEMOTION == event.type:
                        if -1 != showing_hs:
                            if (showing_hs < len(self.hot_spots)) and (not check_point(event.pos, self.hot_spots[showing_hs].hit_rect)):
                                self.screen.blit(self.sur_image, self.rect_image)
                                showing_hs = -1
                                need_flip = True
                        else:
                            for hot_spot in self.hot_spots:
                                if check_point(event.pos, hot_spot.hit_rect):
                                    hot_spot.show(self.screen)
                                    showing_hs = self.hot_spots.index(hot_spot)
                                    need_flip = True

            
                if need_flip:
                    need_flip = False
                    pygame.display.flip()
                    
                self.intro_clock.tick(100)
                            
            pygame.time.set_timer(MOVE_STEP, 0)
            pygame.time.set_timer(TIME_OUT, 0)
            return LE_NORMAL
        
        except Exception, error:
            pygame.time.set_timer(MOVE_STEP, 0)
            pygame.time.set_timer(TIME_OUT, num_of_secs)
            error = "set_scene in the intro class failed:\n%s" % error
            raise

#------------------------------FUNCTIONS---------------------------------------#

def check_point((x, y), rect):
    """
    Checks if the point represented by (x,y) is in the area of the rect.
    """
    if (x > rect.left) and (x < rect.right):
        if (y < rect.bottom) and (y > rect.top):
            return True
        
    return False